//+------------------------------------------------------------------+
//|                                                          DKX.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004,wyd95968"
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1  Gainsboro
#property  indicator_color2  DarkOrange

//---- indicator parameters
extern int M   = 10;
//---- indicator buffers
double     MA[];
double     MB[];
double     MD[];

int        i,j;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 1 additional buffer used for counting.
   IndicatorBuffers(3);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
//   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,MB);
   SetIndexBuffer(1,MD);
   SetIndexBuffer(2,MA);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("DKX("+M+")");
   SetIndexLabel(0,"DKX.B");
   SetIndexLabel(1,"DKX.D");
//----
   SetIndexDrawBegin(0,M);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| MASS Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   double sum1,sum2;
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars<0) return(0);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
A:=(3*C+L+O+H)/6;
  B:(20*A+19*REF(A,1)+18*REF(A,2)+17*REF(A,3)+16*REF(A,4)+15*REF(A,5)+14*REF(A,6)+13*REF(A,7)+12*REF(A,8)+11*REF(A,9)+10*REF(A,10)+9*REF(A,11)+8*REF(A,12)+7*REF(A,13)+6*REF(A,14)+5*REF(A,15)+4*REF(A,16)+3*REF(A,17)+2*REF(A,18)+REF(A,20))/210;
  D:MA(B,M); 

//----  
   for(i=0; i<limit; i++) 
      MA[i]=(Close[i]*3+Low[i]+Open[i]+High[i])/6;
   for(i=0; i<limit; i++)  
      {sum1=0;
       for(j=0;j<20;j++)
         sum1+=(20-j)*MA[i+j];
       MB[i]=sum1/210;                                           //DodgerBlue
      }
//---- ƽ 
   for(i=0;i<limit;i++)
       MD[i]=iMAOnArray(MB,Bars,M,0,MODE_SMA,i);   //Gold
//---- done
   return(0);
  }
//+------------------------------------------------------------------+